#!/bin/sh
###########################################################################
#
#	Ce script prpare l'installation de greylisting pour un postfix
#	2.0.19-xxxxx
#

#
#	Creation du rpertoire avec les bases de donnes triplet
#		whitelist
#		et greylist
#
mkdir /var/mta
chown nobody:nobody /var/mta

#
#	Dpt des excutables
#
mkdir /usr/libexec/postfix/extra
cp greylist.pl /usr/libexec/postfix/extra
cp whitelist.pl /usr/libexec/postfix/extra
cp clean_policy.pl /usr/libexec/postfix/extra

#
#	Ajout dans le main.cf
#		et dans master.cf
#	des ordres concerns
#
cat add_main.cf >>/etc/postfix/main.cf
cat add_master.cf >>/etc/postfix/master.cf

#
#	Ajout de la liste des domaines grs par la greylist
#
cp greydomains /etc/postfix
postmap /etc/postfix/greydomains

#
#	Ajout dans le crontab
#
cat<<__EOF__
Bonjour,

Les fichiers ont t installs  leur emplacement.
Aux fichiers de configuration ont t ajoutes les instructions
ncessaires mais en commentaires. Il vous faut donc les dcommenter pour que
le greylisting fonctionne.


Vous devrez aussi installer le DB_File-Lock-0.05.tar.gz 
cd /usr/local/src
tar zxvf DB_File-Lock-0.05.tar.gz
perl Makefile.PL
make
make install

afin que le processus des locks perl fonctionne correctement.

--------------------------------------------------

Il serait souhaitable d ajouter la ligne suivante dans le crontab
0 3 * * * /usr/libexec/postfix/extra/clean_policy.pl > /dev/null 2>&1
qui permet de mettre  jour la whitelist.
vous pouvez  tout moment dtruire le fichier /var/mta/greylist.db qui se
reconstitue automatiquement, au prix il est vrai d une attente pour les mails

------------------------------------
Pour tester si l outil fonctionne :
faites les manipulations suivantes :
./clean_policy.pl

cat exemple.test|./whitelist.pl
il devrait vous retourner la ligne
action=dunno


cat exemple.test|./greylist.pl
il devrait vous retourner la ligne
action=defer_if_permit Service temporarily unavailable

Puis 60 secondes plus tard
cat exemple.test|./greylist.pl
il devrait vous retourner la ligne
action=dunno


ATTENTION, aprs ces tests vous devrez faire
	chown -R nobody:nobody /var/mta

-------------------------------------
Pour rappel, ce script est une variation sur le travail de Wietse Venema
smtpd-policy.pl qui se trouve dans /usr/libexec/postfix

Vous tes donc encourags  le modifier.

De mme, vous pouvez fort bien vous passer de la notion de "greydomains" et
considrer que le programme fonctionne trs bien tel quel, quelque soit
l expditeur. Pour cela remplacer la ligne
	check_client_access hash:/etc/postfix/greydomains

par 
	check_policy_service unix:private/greylist

et supprimer les 2 lignes :
	smtpd_restriction_classes = grey
	grey = check_policy_service unix:private/greylist

En vous souhaitant une bonne utilisation

__EOF__



